#ifndef _ygGeometry_h_
#define _ygGeometry_h_

#include "ygNode.h"

#define DRAW_OFF 0
#define DRAW_ON 1
#define DRAW_LOCAL 2
#define DRAW_REMOTE 3

class pfNode;
class pfGroup;
class pfGeode;

class ygGeometry : public ygNode
    {
    public:
     ygGeometry(const char* name,bool master=true);
     ~ygGeometry(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
     void setWall(bool);
     void setFloor(bool);
     void setDraw(int);
     void setCull(int);
     void setWireframe(bool);
     void setTransparency(int);
    protected:
     virtual void createDebugNode(void);
     int draw;
     bool wall;
     bool floor;
     bool wireframe;
     int transparency;
     int cull;
     pfGroup* object;
    private:
     void setGeoState(uint64_t,int,pfNode*);
     void setDrawBin(int,int,pfNode*);
     uint isectMask;
     void makeDebugGeosets(pfGeode*);
     pfGeoSet* makeCornerGeoset(void);
    };

extern "C" ygNode* construct_ygGeometry(const char* name,bool master);

#endif
