#ifndef _ygScene_h_
#define _ygScene_h_

#include <vector>
#include <set>
#include "ygParser.h"
#include "ygNode.h"

using namespace std;

class ygScene : public ygNode
    {
    public:
     ygScene(const char* name,bool master=true);
     ~ygScene(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void parseMessage(const ygMessage&,bool force=false);
     virtual void printMessages(std::ostream&,int indent=0,bool comment=false);
    private:
     void loadFile(const ygString&,bool preprocess);
     ygParser parser;
     bool preprocess;
     bool first;
     bool loaded;
     bool reload;
     ygString filename;
     vector<ygString> initMessages;
     set<ygNode*> sceneChildren;
    };


extern "C" ygNode* construct_ygScene(const char*,bool);

#endif
