// Description: establishes a view point for the rendering library
//
//<b>notes:</b>
//<ul>
//<li> derived nodes inherit all messages from their base classes
//<li> added automatically to scene at startup unless the --noview option is used
//</ul>
//
// Category: Foundation
// Author: Dave Pape
//           11/01/01
//           05/01/03 Alex Hill - added setUser() method to use another user perspective
// Revision: 02/01/06 Alex Hill - broke ygCAVEViewer into ygViewer base class and subclass
//
#include <pfcave.h>
#include "ygWorld.h"
#include "ygViewer.h"
#include "ygNodeDB.h"

extern "C" ygNode* construct_ygViewer(const char* name,bool master) { return new ygViewer(name,master); }


ygViewer::ygViewer(const char* name,bool master) : ygTransform(name,master)
    {
    setClassName("ygViewer");
    navigator_ = NULL;
    }


void ygViewer::reset(void)
    {
    ygTransform::reset();
    }


void ygViewer::app(void)
    {
    ygTransform::app();
    }


void ygViewer::setNavigator(ygNavigator* nav)
    {
    navigator_ = nav;
    }
