#include <Performer/pf.h>
#include <Performer/pfdu.h>
#include <Performer/pf/pfSCS.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pr/pfGeoSet.h>

main(int argc, char **argv)
{
 int i;
 pfNode* node;
 pfGroup* group;

 if (argc < 4)
    {
    fprintf(stderr, "usage: %s infile1 infile2 outfile\n", argv[0]);
    exit(1);
    }

 pfInit();
 pfFilePath("/usr/share/Performer/data"
        ":/usr/demos/models"
            ":/usr/demos/data/flt"
        ":/usr/demos/data/textures"
        );
 pfMultiprocess(0);
 pfConfig();
 pfNotifyLevel(PFNFY_INFO);

 group = new pfGroup;
 for (i=1; i<argc-1; i++)
    {
    node = pfdLoadFile(argv[i]);
    pfdPrintSceneGraphStats(node,0.0);
    group->addChild(node);
    }
 pfdStoreFile(group,argv[argc-1]);
}
